var express = require('express');
var app = express();
app.use(express.static('public'));
var server = app.listen(3001, function(){
  console.log('http listening on *:3001');
});
// var http = require('http').createServer(app);
// var https = require("https");
var axios = require('axios');
var io = require('socket.io').listen(server);
// var io = require('socket.io')(http);
// let fs = require("fs");


// app.all('*', function(req, res, next) {
//     res.header("Access-Control-Allow-Origin", "*");
//     res.header("Access-Control-Allow-Headers", "Content-Type,Content-Length, Authorization, Accept,X-Requested-With");
//     res.header("Access-Control-Allow-Methods","PUT,POST,GET,DELETE,OPTIONS");
//     res.header("X-Powered-By",' 3.2.1');
//     res.header("Content-Type", "application/json;charset=utf-8");
//     next();
// });
//allow custom header and CORS
// app.all('*',function (req, res, next) {
//   res.header('Access-Control-Allow-Origin','https://zhibo.xueyoubangedu.com https://livesocket.xueyoubangedu.com');
//   res.header('Access-Control-Allow-Headers', 'Content-Type, Content-Length, Authorization, Accept, X-Requested-With , yourHeaderFeild');
//   res.header('Access-Control-Allow-Methods', 'PUT, POST, GET, DELETE, OPTIONS');

//   if (req.method == 'OPTIONS') {
//     res.send(200); 
//   }
//   else {
//     next();
//   }
// });

// var BaseUrl = "http://localhost/api/";
var BaseUrl = "https://zhibo.xueyoubangedu.com/api/";
// var BaseUrl = "https://live.xueyoubangedu.com/api/";


// const httpsOption = {
//     key : fs.readFileSync("./https/privkey.pem"),
//     cert: fs.readFileSync("./https/fullchain.pem")
// }

app.get('/', function(req, res){
 res.send('<h1>Hello world</h1>');
});

io.on('connection', function(socket){
    console.log("connection");
    //监听用户登录
    socket.on('login', function(obj){
      var userid = obj.userid;
      var roomid = obj.roomid;
      var status = obj.status; //用户状态
      socket.nickname = roomid+ '***' + userid;
      console.log("login------------------"+socket.nickname);
      
      axios.post(BaseUrl + 'websocket/login', {
        roomid: roomid,
        userid: userid,
        status: status
      })
      .then(function (response) {
        // console.log(response.data);
        var str = socket.nickname.split("***");
        var userid = str[1];
        var roomid = str[0];
        io.emit(roomid + 'Login', {userid: userid, roomid: roomid});
      })
      .catch(function (error) {
        console.log(error);
      });
    });
    
    //监听中断
    socket.on('disconnect', function(obj){
      console.log('user disconnected--------'+socket.nickname);
      console.log(obj);
      //最后结束不走中断
      if (obj != 'client namespace disconnect') {
        if (socket.nickname) {
          axios.post(BaseUrl + 'websocket/disconnect', {
            socketName: socket.nickname
          })
          .then(function (response) {
            // console.log(response.data);
            var str = socket.nickname.split("***");
            var userid = str[1];
            var roomid = str[0];
            var user = response.data.data;
            io.emit(roomid + 'BREAKCLASS', {userid: userid, roomid: roomid, user: user});
          })
          .catch(function (error) {
            console.log(error.data);
          });
        }
      }
    });
    //下课
    socket.on('loginout', function(obj){
      console.log("loginout----"+socket.nickname);
      if (socket.nickname) {
        axios.post(BaseUrl + 'websocket/loginout', {
          socketName: socket.nickname
        })
        .then(function (response) {
          // console.log(response.data);
          var str = socket.nickname.split("***");
          var userid = str[1];
          var roomid = str[0];
          var user = response.data.data;
          io.emit(roomid + 'ENDCLASS', {userid: userid, roomid: roomid, user: user});
        })
        .catch(function (error) {
          console.log(error.data);
        });
      }
    });
    //开课
    // socket.on('STARTCLASS', function(obj){
    //   console.log("STARTCLASS----------------------------");
    //   io.emit('STARTCLASS', obj);
    // });
});


// http.listen(3001, function(){
//   console.log('http listening on *:3001');
// });


// https.createServer(httpsOption, app).listen(3000, function(){
//   console.log('https listening on *:3000');
// });